/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package de.mfo.jsurfer.pointcloud;

import javax.vecmath.*;
import java.io.*;

/**
 * Exports points and normals for usage with the PoissonRecon mesh reconstructor.
 * @author Christian Stussak <christian at knorf.de>
 */
public class PoissonReconExporter implements Exporter
{
    PrintStream ps;
    
    public PoissonReconExporter( File file )
        throws IOException
    {
        ps = new PrintStream( new FileOutputStream( file ) );
    }
    
    public void startExport() {}
    
    public void export( Point3d p, Vector3d normal )
    {
        ps.print( p.x + " " + p.y + " " + p.z + " " + normal.x + " " + normal.y + " " + normal.z + " ");
    }

    public void exportBBox( double size ) {}
    
    public void finishExport()
    {
        ps.flush();
        ps.close();
    }
}
